#include "gcd.h"

/* Greatest common divisor
 * https://en.wikipedia.org/wiki/Greatest_common_divisor

int gcd(int a, int b)   // a > 0 && b > 0
{
  if (a > b) return gcd1(a-b, b);
  if (b > a) return gcd1(a, b-a);

  return a;  // a == b
}

int gcd(int a, int b)
{
  if (b == 0) return a > 0 ? a : -a;
  return gcd(b, a - b*(a/b));   // gcd(b,a mod b)
}

*/

int gcd(int a, int b)
{
  int t {};
  for (;;)
    {
      if (b == 0) return a > 0 ? a : -a;
      t = a - b*(a/b);                   // gcd(b,a mod b)
      a = b;
      b = t;
    }
}

