#include <iostream>
#include <vector>

using namespace std;

// pozor na pořadí indexů v inicializačním seznamu
//                   začínáme od absolutního členu
std::vector<double> p {9, 2, 5, 2, 7};
std::vector<double> q {3,-1, 2};
std::vector<double> r {6, 3, 3, 2, 7};

double polynom(std::vector<double> p, double x)
{
    int n = p.size();
    if (n == 0) return 0; // prázdný polynom není definován

    double h = p[--n];
    while (n > 0) {
        h *= x;
        h += p[--n];
    }

    return h;
}

std::vector<double> soucet(std::vector<double> q, std::vector<double> r)
{
   const int nq  = q.size();
   const int nr  = r.size();
   const int max = std::max(nq, nr);
   std::vector<double> p(max, 0);

   for (int i=0; i<max; i++) {
       if (i < nq) p[i] += q[i];
       if (i < nr) p[i] += r[i];
   }

   return p;
}

int main()
{
    cout << "Polynomy" << endl;
    for (double x : vector<double>({0, 0.1, 0.3, 0.5, 0.7, 1})) {
        cout << x << "\t" << polynom(p, x) << " ";
        std::vector<double> s = soucet(q,r);
        cout << polynom(s, x) << endl;
    }
    return 0;
}
